Index: branches/1.3/gui/scripts/vtkvolumeviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/vtkvolumeviewer.tcl	(revision 4828)
+++ branches/1.3/gui/scripts/vtkvolumeviewer.tcl	(revision 4848)
@@ -1586,5 +1511,5 @@
     array set style $_style($tag)
 
-    set name "$style(-color):$style(-levels)"
+    set name "$style(-color):$style(-levels):$style(-opacity)"
     if { ![info exists _colormaps($name)] } {
         BuildColormap $name [array get style]
@@ -1594,5 +1519,5 @@
          $_dataset2style($tag) != $name } {
         SendCmd "volume colormap $name $tag"
-        SendCmd "$_cutplaneCmd colormap $name-opaque $tag"
+        SendCmd "cutplane colormap $name-opaque $tag"
         set _dataset2style($tag) $name
     }
@@ -1608,5 +1533,8 @@
         set cmap "0.0 0.0 0.0 0.0 1.0 1.0 1.0 1.0"
     }
-    set max 1.0
+    if { ![info exists _settings(volume-opacity)] } {
+        set _settings(volume-opacity) $style(-opacity)
+    }
+    set max $_settings(volume-opacity)
 
     set opaqueWmap "0.0 1.0 1.0 1.0"
@@ -1623,8 +1551,6 @@
 itcl::configbody Rappture::VtkVolumeViewer::plotbackground {
     if { [isconnected] } {
-        set color $itk_option(-plotbackground)
-        set rgb [Color2RGB $color]
-        SendCmd "screen bgcolor $rgb"
-        $itk_component(legend) configure -background $color
+        foreach {r g b} [Color2RGB $itk_option(-plotbackground)] break
+        SendCmd "screen bgcolor $r $g $b"
     }
 }
@@ -1635,75 +1561,14 @@
 itcl::configbody Rappture::VtkVolumeViewer::plotforeground {
     if { [isconnected] } {
-        set color $itk_option(-plotforeground)
-        set rgb [Color2RGB $color]
-        SendCmd "axis color all $rgb"
-        SendCmd "outline color $rgb"
-        SendCmd "$_cutplaneCmd color $rgb"
-        $itk_component(legend) itemconfigure labels -fill $color 
-        $itk_component(legend) itemconfigure limits -fill $color 
-    }
-}
-
-itcl::body Rappture::VtkVolumeViewer::BuildViewTab {} {
+        foreach {r g b} [Color2RGB $itk_option(-plotforeground)] break
+        #fix this!
+        #SendCmd "color background $r $g $b"
+    }
+}
+
+itcl::body Rappture::VtkVolumeViewer::BuildVolumeTab {} {
+
     set fg [option get $itk_component(hull) font Font]
     #set bfg [option get $itk_component(hull) boldFont Font]
-
-    set inner [$itk_component(main) insert end \
-        -title "View Settings" \
-        -icon [Rappture::icon wrench]]
-    $inner configure -borderwidth 4
-
-    checkbutton $inner.axes \
-        -text "Axes" \
-        -variable [itcl::scope _settings(-axesvisible)] \
-        -command [itcl::code $this AdjustSetting -axesvisible] \
-        -font "Arial 9"
-
-    checkbutton $inner.outline \
-        -text "Outline" \
-        -variable [itcl::scope _settings(-volumeoutline)] \
-        -command [itcl::code $this AdjustSetting -volumeoutline] \
-        -font "Arial 9"
-
-    checkbutton $inner.legend \
-        -text "Legend" \
-        -variable [itcl::scope _settings(-legendvisible)] \
-        -command [itcl::code $this AdjustSetting -legendvisible] \
-        -font "Arial 9"
-
-    checkbutton $inner.volume \
-        -text "Volume" \
-        -variable [itcl::scope _settings(-volumevisible)] \
-        -command [itcl::code $this AdjustSetting -volumevisible] \
-        -font "Arial 9"
-
-    label $inner.background_l -text "Background" -font "Arial 9" 
-    itk_component add background {
-        Rappture::Combobox $inner.background -width 10 -editable no
-    }
-    $inner.background choices insert end \
-        "black"              "black"            \
-        "white"              "white"            \
-        "grey"               "grey"             
-
-    $itk_component(background) value $_settings(-background)
-    bind $inner.background <<Value>> \
-        [itcl::code $this AdjustSetting -background]
-
-    blt::table $inner \
-        0,0 $inner.axes  -cspan 2 -anchor w \
-        1,0 $inner.outline  -cspan 2 -anchor w \
-        2,0 $inner.volume  -cspan 2 -anchor w \
-        3,0 $inner.legend  -cspan 2 -anchor w \
-        4,0 $inner.background_l       -anchor e -pady 2 \
-        4,1 $inner.background                   -fill x \
-
-    blt::table configure $inner r* -resize none
-    blt::table configure $inner r5 -resize expand
-}
-
-itcl::body Rappture::VtkVolumeViewer::BuildVolumeTab {} {
-    set font [option get $itk_component(hull) font Font]
-    #set bfont [option get $itk_component(hull) boldFont Font]
 
     set inner [$itk_component(main) insert end \
@@ -1712,70 +1577,92 @@
     $inner configure -borderwidth 4
 
-    checkbutton $inner.visibility \
-        -text "Visible" \
-        -font $font \
-        -variable [itcl::scope _settings(-volumevisible)] \
-        -command [itcl::code $this AdjustSetting -volumevisible]
+    checkbutton $inner.volume \
+        -text "Show Volume" \
+        -variable [itcl::scope _settings(volumeVisible)] \
+        -command [itcl::code $this AdjustSetting volumeVisible] \
+        -font "Arial 9"
 
     checkbutton $inner.lighting \
         -text "Enable Lighting" \
-        -font $font \
-        -variable [itcl::scope _settings(-volumelighting)] \
-        -command [itcl::code $this AdjustSetting -volumelighting]
-
-    label $inner.dim_l -text "Dim" -font $font
+        -variable [itcl::scope _settings(volumeLighting)] \
+        -command [itcl::code $this AdjustSetting volumeLighting] \
+        -font "Arial 9"
+
+    label $inner.dim_l -text "Dim" -font "Arial 9"
     ::scale $inner.material -from 0 -to 100 -orient horizontal \
-        -variable [itcl::scope _settings(-volumematerial)] \
-        -showvalue off -command [itcl::code $this AdjustSetting -volumematerial]
-    label $inner.bright_l -text "Bright" -font $font
-
-    label $inner.opacity_l -text "Opacity" -font $font
+        -variable [itcl::scope _settings(volume-material)] \
+        -width 10 \
+        -showvalue off -command [itcl::code $this AdjustSetting volume-material]
+    label $inner.bright_l -text "Bright" -font "Arial 9"
+
+    label $inner.opacity_l -text "Opacity" -font "Arial 9"
     ::scale $inner.opacity -from 0 -to 100 -orient horizontal \
-        -variable [itcl::scope _settings(-volumeopacity)] \
+        -variable [itcl::scope _settings(volume-opacity)] \
+        -width 10 \
         -showvalue off \
-        -command [itcl::code $this AdjustSetting -volumeopacity]
-
-    label $inner.quality_l -text "Quality" -font $font
+        -command [itcl::code $this AdjustSetting volume-opacity]
+
+    label $inner.quality_l -text "Quality" -font "Arial 9"
     ::scale $inner.quality -from 0 -to 100 -orient horizontal \
-        -variable [itcl::scope _settings(-volumequality)] \
-        -showvalue off \
-        -command [itcl::code $this AdjustSetting -volumequality]
-
-    label $inner.field_l -text "Field" -font $font
+        -variable [itcl::scope _settings(volume-quality)] \
+        -width 10 \
+        -showvalue off -command [itcl::code $this AdjustSetting volume-quality]
+
+    itk_component add field_l {
+        label $inner.field_l -text "Field" -font "Arial 9" 
+    } {
+        ignore -font
+    }
     itk_component add field {
-        Rappture::Combobox $inner.field -editable no
+        Rappture::Combobox $inner.field -width 10 -editable no
     }
     bind $inner.field <<Value>> \
-        [itcl::code $this AdjustSetting -field]
-
-    label $inner.colormap_l -text "Colormap" -font $font
-    itk_component add colormap {
-        Rappture::Combobox $inner.colormap -editable no
-    }
-    $inner.colormap choices insert end [GetColormapList]
-    bind $inner.colormap <<Value>> \
-        [itcl::code $this AdjustSetting -color]
-    $itk_component(colormap) value $_settings(-color)
+        [itcl::code $this AdjustSetting field]
+
+    label $inner.palette_l -text "Palette" -font "Arial 9" 
+    itk_component add palette {
+        Rappture::Combobox $inner.palette -width 10 -editable no
+    }
+    $inner.palette choices insert end \
+        "BCGYR"              "BCGYR"            \
+        "BGYOR"              "BGYOR"            \
+        "blue"               "blue"             \
+        "blue-to-brown"      "blue-to-brown"    \
+        "blue-to-orange"     "blue-to-orange"   \
+        "blue-to-grey"       "blue-to-grey"     \
+        "green-to-magenta"   "green-to-magenta" \
+        "greyscale"          "greyscale"        \
+        "nanohub"            "nanohub"          \
+        "rainbow"            "rainbow"          \
+        "spectral"           "spectral"         \
+        "ROYGB"              "ROYGB"            \
+        "RYGCB"              "RYGCB"            \
+        "brown-to-blue"      "brown-to-blue"    \
+        "grey-to-blue"       "grey-to-blue"     \
+        "orange-to-blue"     "orange-to-blue"   
+
+    $itk_component(palette) value "BCGYR"
+    bind $inner.palette <<Value>> \
+        [itcl::code $this AdjustSetting volume-palette]
 
     blt::table $inner \
         0,0 $inner.field_l   -anchor w -pady 2  \
-        0,1 $inner.field     -fill x   -pady 2 -cspan 3 \
-        1,0 $inner.visibility -anchor w -pady 2 -cspan 4 \
+        0,1 $inner.field     -anchor w -pady 2 -cspan 2 \
+        1,0 $inner.volume    -anchor w -pady 2 -cspan 4 \
         2,0 $inner.lighting  -anchor w -pady 2 -cspan 4 \
         3,0 $inner.dim_l     -anchor e -pady 2 \
-        3,1 $inner.material  -fill x   -pady 2 -cspan 2 \
-        3,3 $inner.bright_l  -anchor w -pady 2 \
-        4,0 $inner.opacity_l -anchor w -pady 2 -cspan 4 \
-        5,0 $inner.opacity   -fill x   -pady 2 -cspan 4 \
-        6,0 $inner.quality_l -anchor w -pady 2 -cspan 4 \
-        7,0 $inner.quality   -fill x   -pady 2 -cspan 4 \
-        8,0 $inner.colormap_l -anchor w -pady 2  \
-        8,1 $inner.colormap   -fill x   -pady 2 -cspan 3 \
-
-    blt::table configure $inner r* c0 c1 c3 -resize none
-    blt::table configure $inner r9 c2 -resize expand
+        3,1 $inner.material  -fill x   -pady 2 \
+        3,2 $inner.bright_l  -anchor w -pady 2 \
+        4,0 $inner.quality_l -anchor w -pady 2 -cspan 2 \
+        5,0 $inner.quality   -fill x   -pady 2 -cspan 2 \
+        7,0 $inner.palette_l -anchor w -pady 2  \
+        7,1 $inner.palette   -anchor w -pady 2 -cspan 2 \
+
+    blt::table configure $inner r* c* -resize none
+    blt::table configure $inner r8 -resize expand
 }
 
 itcl::body Rappture::VtkVolumeViewer::BuildAxisTab {} {
+
     set fg [option get $itk_component(hull) font Font]
     #set bfg [option get $itk_component(hull) boldFont Font]
@@ -1783,38 +1670,33 @@
     set inner [$itk_component(main) insert end \
         -title "Axis Settings" \
-        -icon [Rappture::icon axis2]]
+        -icon [Rappture::icon axis1]]
     $inner configure -borderwidth 4
 
     checkbutton $inner.visible \
-        -text "Axes" \
-        -variable [itcl::scope _settings(-axesvisible)] \
-        -command [itcl::code $this AdjustSetting -axesvisible] \
+        -text "Show Axes" \
+        -variable [itcl::scope _settings(axesVisible)] \
+        -command [itcl::code $this AdjustSetting axesVisible] \
         -font "Arial 9"
 
     checkbutton $inner.labels \
-        -text "Axis Labels" \
-        -variable [itcl::scope _settings(-axislabels)] \
-        -command [itcl::code $this AdjustSetting -axislabels] \
+        -text "Show Axis Labels" \
+        -variable [itcl::scope _settings(axisLabels)] \
+        -command [itcl::code $this AdjustSetting axisLabels] \
         -font "Arial 9"
-    label $inner.grid_l -text "Grid" -font "Arial 9"
-    checkbutton $inner.xgrid \
-        -text "X" \
-        -variable [itcl::scope _settings(-xgrid)] \
-        -command [itcl::code $this AdjustSetting -xgrid] \
+
+    checkbutton $inner.gridx \
+        -text "Show X Grid" \
+        -variable [itcl::scope _settings(axis-xgrid)] \
+        -command [itcl::code $this AdjustSetting axis-xgrid] \
         -font "Arial 9"
-    checkbutton $inner.ygrid \
-        -text "Y" \
-        -variable [itcl::scope _settings(-ygrid)] \
-        -command [itcl::code $this AdjustSetting -ygrid] \
+    checkbutton $inner.gridy \
+        -text "Show Y Grid" \
+        -variable [itcl::scope _settings(axis-ygrid)] \
+        -command [itcl::code $this AdjustSetting axis-ygrid] \
         -font "Arial 9"
-    checkbutton $inner.zgrid \
-        -text "Z" \
-        -variable [itcl::scope _settings(-zgrid)] \
-        -command [itcl::code $this AdjustSetting -zgrid] \
-        -font "Arial 9"
-    checkbutton $inner.minorticks \
-        -text "Minor Ticks" \
-        -variable [itcl::scope _settings(-axisminorticks)] \
-        -command [itcl::code $this AdjustSetting -axisminorticks] \
+    checkbutton $inner.gridz \
+        -text "Show Z Grid" \
+        -variable [itcl::scope _settings(axis-zgrid)] \
+        -command [itcl::code $this AdjustSetting axis-zgrid] \
         -font "Arial 9"
 
@@ -1827,24 +1709,22 @@
         "static_triad"    "static" \
         "closest_triad"   "closest" \
-        "furthest_triad"  "farthest" \
+        "furthest_triad"  "furthest" \
         "outer_edges"     "outer"         
-    $itk_component(axismode) value $_settings(-axisflymode)
-    bind $inner.mode <<Value>> [itcl::code $this AdjustSetting -axisflymode]
+    $itk_component(axismode) value "static"
+    bind $inner.mode <<Value>> [itcl::code $this AdjustSetting axisFlyMode]
 
     blt::table $inner \
-        0,0 $inner.visible -anchor w -cspan 4 \
-        1,0 $inner.labels  -anchor w -cspan 4 \
-        2,0 $inner.minorticks  -anchor w -cspan 4 \
-        4,0 $inner.grid_l  -anchor w \
-        4,1 $inner.xgrid   -anchor w \
-        4,2 $inner.ygrid   -anchor w \
-        4,3 $inner.zgrid   -anchor w \
-        5,0 $inner.mode_l  -anchor w -padx { 2 0 } \
-        5,1 $inner.mode    -fill x   -cspan 3
+        0,0 $inner.visible -anchor w -cspan 2 \
+        1,0 $inner.labels  -anchor w -cspan 2 \
+        2,0 $inner.gridx   -anchor w -cspan 2 \
+        3,0 $inner.gridy   -anchor w -cspan 2 \
+        4,0 $inner.gridz   -anchor w -cspan 2 \
+        5,0 $inner.mode_l  -anchor w -cspan 2 -padx { 2 0 } \
+        6,0 $inner.mode    -fill x   -cspan 2 
 
     blt::table configure $inner r* c* -resize none
-    blt::table configure $inner r7 c6 -resize expand
-    blt::table configure $inner r3 -height 0.125i
-}
+    blt::table configure $inner r7 c1 -resize expand
+}
+
 
 itcl::body Rappture::VtkVolumeViewer::BuildCameraTab {} {
@@ -1854,29 +1734,14 @@
     $inner configure -borderwidth 4
 
-    label $inner.view_l -text "view" -font "Arial 9"
-    set f [frame $inner.view]
-    foreach side { front back left right top bottom } {
-        button $f.$side  -image [Rappture::icon view$side] \
-            -command [itcl::code $this SetOrientation $side]
-        Rappture::Tooltip::for $f.$side "Change the view to $side"
-        pack $f.$side -side left
-    }
-    blt::table $inner \
-        0,0 $inner.view_l -anchor e -pady 2 \
-        0,1 $inner.view -anchor w -pady 2
-    blt::table configure $inner r0 -resize none
-
-    set row 1
     set labels { qx qy qz qw xpan ypan zoom }
+    set row 0
     foreach tag $labels {
-        label $inner.${tag}-label -text $tag -font "Arial 9"
+        label $inner.${tag}label -text $tag -font "Arial 9"
         entry $inner.${tag} -font "Arial 9"  -bg white \
-            -textvariable [itcl::scope _view(-$tag)]
-        bind $inner.${tag} <Return> \
-            [itcl::code $this camera set -${tag}]
-        bind $inner.${tag} <KP_Enter> \
-            [itcl::code $this camera set -${tag}]
+            -textvariable [itcl::scope _view($tag)]
+        bind $inner.${tag} <KeyPress-Return> \
+            [itcl::code $this camera set ${tag}]
         blt::table $inner \
-            $row,0 $inner.${tag}-label -anchor e -pady 2 \
+            $row,0 $inner.${tag}label -anchor e -pady 2 \
             $row,1 $inner.${tag} -anchor w -pady 2
         blt::table configure $inner r$row -resize none
@@ -1885,6 +1750,6 @@
     checkbutton $inner.ortho \
         -text "Orthographic Projection" \
-        -variable [itcl::scope _view(-ortho)] \
-        -command [itcl::code $this camera set -ortho] \
+        -variable [itcl::scope _view(ortho)] \
+        -command [itcl::code $this camera set ortho] \
         -font "Arial 9"
     blt::table $inner \
@@ -1899,5 +1764,6 @@
 
 itcl::body Rappture::VtkVolumeViewer::BuildCutplaneTab {} {
-    set font [option get $itk_component(hull) font Font]
+
+    set fg [option get $itk_component(hull) font Font]
     
     set inner [$itk_component(main) insert end \
@@ -1909,21 +1775,33 @@
     checkbutton $inner.visible \
         -text "Show Cutplanes" \
-        -variable [itcl::scope _settings(-cutplanesvisible)] \
-        -command [itcl::code $this AdjustSetting -cutplanesvisible] \
+        -variable [itcl::scope _settings(cutplaneVisible)] \
+        -command [itcl::code $this AdjustSetting cutplaneVisible] \
+        -font "Arial 9"
+
+    checkbutton $inner.wireframe \
+        -text "Show Wireframe" \
+        -variable [itcl::scope _settings(cutplaneWireframe)] \
+        -command [itcl::code $this AdjustSetting cutplaneWireframe] \
         -font "Arial 9"
 
     checkbutton $inner.lighting \
         -text "Enable Lighting" \
-        -variable [itcl::scope _settings(-cutplanelighting)] \
-        -command [itcl::code $this AdjustSetting -cutplanelighting] \
+        -variable [itcl::scope _settings(cutplaneLighting)] \
+        -command [itcl::code $this AdjustSetting cutplaneLighting] \
+        -font "Arial 9"
+
+    checkbutton $inner.edges \
+        -text "Show Edges" \
+        -variable [itcl::scope _settings(cutplaneEdges)] \
+        -command [itcl::code $this AdjustSetting cutplaneEdges] \
         -font "Arial 9"
 
     label $inner.opacity_l -text "Opacity" -font "Arial 9"
     ::scale $inner.opacity -from 0 -to 100 -orient horizontal \
-        -variable [itcl::scope _settings(-cutplaneopacity)] \
+        -variable [itcl::scope _settings(cutplane-opacity)] \
         -width 10 \
         -showvalue off \
-        -command [itcl::code $this AdjustSetting -cutplaneopacity]
-    $inner.opacity set $_settings(-cutplaneopacity)
+        -command [itcl::code $this AdjustSetting cutplane-opacity]
+    $inner.opacity set $_settings(cutplane-opacity)
 
     # X-value slicer...
@@ -1932,6 +1810,6 @@
             -onimage [Rappture::icon x-cutplane] \
             -offimage [Rappture::icon x-cutplane] \
-            -command [itcl::code $this AdjustSetting -xcutplanevisible] \
-            -variable [itcl::scope _settings(-xcutplanevisible)]
+            -command [itcl::code $this AdjustSetting cutplane-xvisible] \
+            -variable [itcl::scope _settings(cutplane-xvisible)]
     }
     Rappture::Tooltip::for $itk_component(xCutButton) \
@@ -1944,5 +1822,5 @@
             -borderwidth 1 -highlightthickness 0 \
             -command [itcl::code $this EventuallySetCutplane x] \
-            -variable [itcl::scope _settings(-xcutplaneposition)]
+            -variable [itcl::scope _settings(cutplane-xposition)]
     } {
         usual
@@ -1960,6 +1838,6 @@
             -onimage [Rappture::icon y-cutplane] \
             -offimage [Rappture::icon y-cutplane] \
-            -command [itcl::code $this AdjustSetting -ycutplanevisible] \
-            -variable [itcl::scope _settings(-ycutplanevisible)]
+            -command [itcl::code $this AdjustSetting cutplane-yvisible] \
+            -variable [itcl::scope _settings(cutplane-yvisible)]
     }
     Rappture::Tooltip::for $itk_component(yCutButton) \
@@ -1972,5 +1850,5 @@
             -borderwidth 1 -highlightthickness 0 \
             -command [itcl::code $this EventuallySetCutplane y] \
-            -variable [itcl::scope _settings(-ycutplaneposition)]
+            -variable [itcl::scope _settings(cutplane-yposition)]
     } {
         usual
@@ -1988,6 +1866,6 @@
             -onimage [Rappture::icon z-cutplane] \
             -offimage [Rappture::icon z-cutplane] \
-            -command [itcl::code $this AdjustSetting -zcutplanevisible] \
-            -variable [itcl::scope _settings(-zcutplanevisible)]
+            -command [itcl::code $this AdjustSetting cutplane-zvisible] \
+            -variable [itcl::scope _settings(cutplane-zvisible)]
     }
     Rappture::Tooltip::for $itk_component(zCutButton) \
@@ -2000,5 +1878,5 @@
             -borderwidth 1 -highlightthickness 0 \
             -command [itcl::code $this EventuallySetCutplane z] \
-            -variable [itcl::scope _settings(-zcutplaneposition)]
+            -variable [itcl::scope _settings(cutplane-zposition)]
     } {
         usual
@@ -2013,15 +1891,17 @@
         0,0 $inner.visible              -anchor w -pady 2 -cspan 4 \
         1,0 $inner.lighting             -anchor w -pady 2 -cspan 4 \
-        2,0 $inner.opacity_l            -anchor w -pady 2 -cspan 3 \
-        3,0 $inner.opacity              -fill x   -pady 2 -cspan 3 \
-        4,0 $itk_component(xCutButton)  -anchor e -padx 2 -pady 2 \
-        5,0 $itk_component(xCutScale)   -fill y \
-        4,1 $itk_component(yCutButton)  -anchor e -padx 2 -pady 2 \
-        5,1 $itk_component(yCutScale)   -fill y \
-        4,2 $itk_component(zCutButton)  -anchor e -padx 2 -pady 2 \
-        5,2 $itk_component(zCutScale)   -fill y
+        2,0 $inner.wireframe            -anchor w -pady 2 -cspan 4 \
+        3,0 $inner.edges                -anchor w -pady 2 -cspan 4 \
+        4,0 $inner.opacity_l            -anchor w -pady 2 -cspan 3 \
+        5,0 $inner.opacity              -fill x   -pady 2 -cspan 3 \
+        6,0 $itk_component(xCutButton)  -anchor e -padx 2 -pady 2 \
+        7,0 $itk_component(xCutScale)   -fill y \
+        6,1 $itk_component(yCutButton)  -anchor e -padx 2 -pady 2 \
+        7,1 $itk_component(yCutScale)   -fill y \
+        6,2 $itk_component(zCutButton)  -anchor e -padx 2 -pady 2 \
+        7,2 $itk_component(zCutScale)   -fill y \
 
     blt::table configure $inner r* c* -resize none
-    blt::table configure $inner r5 c3 -resize expand
+    blt::table configure $inner r7 c3 -resize expand
 }
 
@@ -2042,6 +1922,6 @@
             }
             switch -- $who {
-                "-ortho" {
-                    if {$_view(-ortho)} {
+                "ortho" {
+                    if {$_view(ortho)} {
                         SendCmd "camera mode ortho"
                     } else {
@@ -2049,14 +1929,14 @@
                     }
                 }
-                "-xpan" - "-ypan" {
+                "xpan" - "ypan" {
                     PanCamera
                 }
-                "-qx" - "-qy" - "-qz" - "-qw" {
-                    set q [ViewToQuaternion]
+                "qx" - "qy" - "qz" - "qw" {
+                    set q [list $_view(qw) $_view(qx) $_view(qy) $_view(qz)]
                     $_arcball quaternion $q
                     EventuallyRotate $q
                 }
-                "-zoom" {
-                    SendCmd "camera zoom $_view(-zoom)"
+                "zoom" {
+                    SendCmd "camera zoom $_view(zoom)"
                 }
             }
@@ -2128,32 +2008,31 @@
 }
 
-itcl::body Rappture::VtkVolumeViewer::SetObjectStyle { dataobj cname } {
+itcl::body Rappture::VtkVolumeViewer::SetObjectStyle { dataobj comp } {
     # Parse style string.
-    set tag $dataobj-$cname
-    array set styles {
-        -lighting   1
-        -opacity    0.5
-        -outline    0
-        -visible    1
-    }
-    array set styles [$dataobj style $cname]
-    set _settings(-volumelighting) $styles(-lighting)
-    set _settings(-volumeopacity) [expr $styles(-opacity) * 100.0]
-    set _settings(-volumeoutline) $styles(-outline)
-    set _settings(-volumevisible) $styles(-visible)
-
-    SendCmd "outline add $tag"
-    SendCmd "outline color [Color2RGB $itk_option(-plotforeground)] $tag"
-    SendCmd "outline visible $styles(-outline) $tag"
-
-    SendCmd "$_cutplaneCmd add $tag"
-    SendCmd "$_cutplaneCmd color [Color2RGB $itk_option(-plotforeground)] $tag"
-    SendCmd "$_cutplaneCmd visible 0 $tag"
-
+    set tag $dataobj-$comp
+    set style [$dataobj style $comp]
+    array set settings {
+        -color \#808080
+        -edges 0
+        -edgecolor black
+        -linewidth 1.0
+        -opacity 0.4
+        -wireframe 0
+        -lighting 1
+        -seeds 1
+        -seedcolor white
+        -visible 1
+    }
+    if { $dataobj != $_first } {
+        set settings(-opacity) 1
+    }
+    array set settings $style
     SendCmd "volume add $tag"
-    SendCmd "volume lighting $styles(-lighting) $tag"
-    SendCmd "volume opacity $styles(-opacity) $tag"
-    SendCmd "volume visible $styles(-visible) $tag"
-    SetColormap $dataobj $cname
+    SendCmd "cutplane add $tag"
+    SendCmd "cutplane visible 0 $tag"
+
+    SendCmd "volume lighting $settings(-lighting) $tag"
+    set _settings(volumeLighting) $settings(-lighting)
+    SetColormap $dataobj $comp
 }
 
@@ -2174,5 +2053,6 @@
 itcl::body Rappture::VtkVolumeViewer::ReceiveLegend { colormap title vmin vmax size } {
     set _legendPending 0
-    if { [isconnected] } {
+    #puts stderr "ReceiveLegend colormap=$colormap title=$title range=$vmin,$vmax size=$size"
+    if { [IsConnected] } {
         set bytes [ReceiveBytes $size]
         if { ![info exists _image(legend)] } {
@@ -2209,5 +2089,5 @@
         set title $fname
     }
-    if { $_settings(-legendvisible) } {
+    if { $_settings(legendVisible) } {
         set x [expr $w - 2]
         if { [$c find withtag "legend"] == "" } {
@@ -2346,5 +2226,5 @@
             }
             set newpos [expr {0.01*$newval}]
-            SendCmd "$_cutplaneCmd slice $axis $newpos"
+            SendCmd "cutplane slice $axis $newpos"
         }
         "tooltip" {
@@ -2358,4 +2238,5 @@
     }
 }
+
 
 # ----------------------------------------------------------------------
@@ -2384,9 +2265,9 @@
         }
         deactivate {
-            $c itemconfigure title -fill $itk_option(-plotforeground) 
+            $c itemconfigure title -fill white 
         }
         invoke {
-            $itk_component(field) value $_curFldLabel
-            AdjustSetting -field
+            $itk_component(field) value _curFldLabel
+            AdjustSetting field
         }
         default {
@@ -2396,37 +2277,2 @@
 }
 
-itcl::body Rappture::VtkVolumeViewer::SetOrientation { side } { 
-    array set positions {
-        front "1 0 0 0"
-        back  "0 0 1 0"
-        left  "0.707107 0 -0.707107 0"
-        right "0.707107 0 0.707107 0"
-        top   "0.707107 -0.707107 0 0"
-        bottom "0.707107 0.707107 0 0"
-    }
-    foreach name { -qw -qx -qy -qz } value $positions($side) {
-        set _view($name) $value
-    } 
-    set q [ViewToQuaternion]
-    $_arcball quaternion $q
-    SendCmd "camera orient $q" 
-    SendCmd "camera reset"
-    set _view(-xpan) 0
-    set _view(-ypan) 0
-    set _view(-zoom) 1.0
-}
-
-#
-# GetDatasetsWithComponents --
-#
-#       Returns a list of all the datasets (known by the combination of
-#       their data object and component name) that match the given 
-#       component name.  For example, this is used where we want to change 
-#       the settings of volumes that have the current component.
-#
-itcl::body Rappture::VtkVolumeViewer::GetDatasetsWithComponent { cname } { 
-    if { ![info exists _volcomponents($cname)] } {
-        return ""
-    }
-    return $_volcomponents($cname)
-}
